/* -*- mode: C++ ; c-basic-offset: 2; indent-tabs-mode: nil -*- */

%include "std_string.i"
%include "std_vector.i"
%include "std_pair.i"

%include "nds_buffer.i"

%{
#include "nds_availability.hh"

using NDS::epoch;
using namespace NDS;
%}

struct segment
{
	std::string frame_type;
	buffer::gps_second_type gps_start;
	buffer::gps_second_type gps_stop;

	segment();
	segment(buffer::gps_second_type gps_start, buffer::gps_second_type gps_stop);
	segment(std::string frame_type, buffer::gps_second_type gps_start, buffer::gps_second_type gps_stop);
};

struct simple_segment {
	typedef buffer::gps_second_type gps_second_type;

	simple_segment();
	simple_segment(const simple_segment &other);
	~simple_segment();
	simple_segment(gps_second_type start, gps_second_type stop);


	// this is ignored by SWIG
	//simple_segment &operator=(const simple_segment &other);

	gps_second_type gps_start;
	gps_second_type gps_stop;
};

%template(vectorSimpleSegment) std::vector<simple_segment>;
class simple_segment_list_type : public std::vector<simple_segment> {
public:
};

%template(vectorSimpleSegmentListType) std::vector<simple_segment_list_type>;
class simple_availability_list_type:public std::vector<simple_segment_list_type> {
public:
};

%template(vectorSegment) std::vector<segment>;
class segment_list_type: public std::vector<segment> {
public:
};


struct availability
{
	std::string name;
	segment_list_type data;

	simple_segment_list_type simple_list();
};

%template(availabilityListType) std::vector<availability>;
class availability_list_type: public std::vector<availability> {
public:
	~availability_list_type();

	simple_availability_list_type simple_list() const;
};
